#ifndef FEC_H
#define FEC_H


typedef struct fec_parms *fec_code_t;

/*
 * create a new encoder, returning a descriptor. This contains k,n and
 * the encoding matrix.
 * n is the number of data blocks + fec blocks (matrix height)
 * k is just the data blocks (matrix width)
 */
void init_fec();

void fec_encode(int blockSize,
		unsigned char **data_blocks,
		int nrDataBlocks,
		unsigned char **fec_blocks,
		int nrFecBlocks);

void fec_decode(int blockSize,
		unsigned char **data_blocks,
		int nr_data_blocks,
		unsigned char **fec_blocks,
		int *fec_block_nos,
		int *erased_blocks,
		short nr_fec_blocks  /* how many blocks per stripe */);

void fec_print(fec_code_t code, int width);

#endif
